JspFactory (JSP 2.3 API Documentation - Apache Tomcat 9.0.120)
Description: declaration: package: javax.servlet.jsp, class: JspFactory

# Class JspFactory

java.lang.Object
javax.servlet.jsp.JspFactory

public abstract class JspFactory extends Object

The JspFactory is an abstract class that defines a number of factory methods available to a JSP page at runtime for the purposes of creating instances of various interfaces and classes used to support the JSP implementation.

A conformant JSP Engine implementation will, during it's initialization instantiate an implementation dependent subclass of this class, and make it globally available for use by JSP implementation classes by registering the instance created with this class via the static `setDefaultFactory()` method.

The PageContext and the JspEngineInfo classes are the only implementation-dependent classes that can be created from the factory.

JspFactory objects should not be used by JSP page authors.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JspFactory()`
  Sole constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static JspFactory`
  `getDefaultFactory()`
  Returns the default factory for this implementation.
  `abstract JspEngineInfo`
  `getEngineInfo()`
  called to get implementation-specific information on the current JSP engine.
  `abstract JspApplicationContext`
  `getJspApplicationContext(javax.servlet.ServletContext context)`
  Obtain the `JspApplicationContext` instance that was associated within the passed `ServletContext` for this web application.
  `abstract PageContext`
  `getPageContext(javax.servlet.Servlet servlet, javax.servlet.ServletRequest request, javax.servlet.ServletResponse response, String errorPageURL, boolean needsSession, int buffer, boolean autoflush)`
  obtains an instance of an implementation dependent javax.servlet.jsp.PageContext abstract class for the calling Servlet and currently pending request and response.
  `abstract void`
  `releasePageContext(PageContext pc)`
  called to release a previously allocated PageContext object.
  `static void`
  `setDefaultFactory(JspFactory deflt)`
  set the default factory for this implementation.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JspFactory

    public JspFactory()
    Sole constructor. (For invocation by subclass constructors, typically implicit.)

- ## Method Details

  - ### setDefaultFactory

    public static void setDefaultFactory(JspFactory deflt)

    set the default factory for this implementation. It is illegal for any principal other than the JSP Engine runtime to call this method.

    Parameters:
      `deflt` - The default factory implementation

  - ### getDefaultFactory

    public static JspFactory getDefaultFactory()
    Returns the default factory for this implementation.
    Returns:
      the default factory for this implementation

  - ### getPageContext

    public abstract PageContext getPageContext(javax.servlet.Servlet servlet, javax.servlet.ServletRequest request, javax.servlet.ServletResponse response, String errorPageURL, boolean needsSession, int buffer, boolean autoflush)

    obtains an instance of an implementation dependent javax.servlet.jsp.PageContext abstract class for the calling Servlet and currently pending request and response.

    This method is typically called early in the processing of the _jspService() method of a JSP implementation class in order to obtain a PageContext object for the request being processed.

    Invoking this method shall result in the PageContext.initialize() method being invoked. The PageContext returned is properly initialized.

    All PageContext objects obtained via this method shall be released by invoking releasePageContext().

    Parameters:
      `servlet` - the requesting servlet
      `request` - the current request pending on the servlet
      `response` - the current response pending on the servlet
      `errorPageURL` - the URL of the error page for the requesting JSP, or null
      `needsSession` - true if the JSP participates in a session
      `buffer` - size of buffer in bytes, `JspWriter.NO_BUFFER` if no buffer, `JspWriter.DEFAULT_BUFFER` if implementation default.
      `autoflush` - should the buffer autoflush to the output stream on buffer overflow, or throw an IOException?
    Returns:
      the page context
    See Also:
      - `PageContext`

  - ### releasePageContext

    public abstract void releasePageContext(PageContext pc)

    called to release a previously allocated PageContext object. Results in PageContext.release() being invoked. This method should be invoked prior to returning from the _jspService() method of a JSP implementation class.

    Parameters:
      `pc` - A PageContext previously obtained by getPageContext()

  - ### getEngineInfo

    public abstract JspEngineInfo getEngineInfo()

    called to get implementation-specific information on the current JSP engine.

    Returns:
      a JspEngineInfo object describing the current JSP engine

  - ### getJspApplicationContext

    public abstract JspApplicationContext getJspApplicationContext(javax.servlet.ServletContext context)

    Obtain the `JspApplicationContext` instance that was associated within the passed `ServletContext` for this web application.

    Parameters:
      `context` - the current web application's `ServletContext`
    Returns:
      `JspApplicationContext` instance
    Since:
      JSP 2.1